//******************************************************************************
// Einlesen_Konverter.c
//******************************************************************************
//  Autor          Datum       Version       Änderung
//  boigk.net      12.02.2020   0.1          Start
//******************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>

#define ANZAHL_BYTES 518

void vFehlerMeldeFunktion(char *pcMeldung);

//************************************************************************/
//* Es gibt nur eine main-Funktion
//************************************************************************/
int main()
{
  //***************************************************
  // Variablen
  //***************************************************
  char Buffer[ANZAHL_BYTES];     //Puffer für Daten
  int i;                         //Zählvariable für Schleife
  FILE *fDaten_Datei;            //Datei Handle für DMX Werte
  unsigned char cKBuffer[10];    //Buffer zum Schreiben der 
                                 //Konvertierten Werte.
                                 //Max 255 Dezimal plus
                                 //Zeilenumbruch

  //***************************************************
  // Code
  //***************************************************
      //***************************************************
      // Hole Daten vom Dateisystem
      //***************************************************
      fDaten_Datei = fopen("Config/SendeDaten.dmx","r");
      if(fDaten_Datei == 0)
      {
         vFehlerMeldeFunktion("Konverter. Kann SendeDaten.dmx nicht öffnen!");
      }
      else
      {
        fread(Buffer,ANZAHL_BYTES,1,fDaten_Datei);
        //***************************************************
        // Schließe Datei
        //***************************************************
        fclose(fDaten_Datei);
      }

      //***************************************************
      // Öffne Datei zum Schreiben
      // Und schreibe zeilenweise konvertierte Daten
      //***************************************************
      fDaten_Datei = fopen("Config/KLDaten.dmp","w+");
      for(i=0;i<ANZAHL_BYTES;i++)
      {
        sprintf(cKBuffer, "%d\n", (unsigned char)Buffer[i]);
        fputs(cKBuffer,fDaten_Datei);
      }


      fclose(fDaten_Datei);



  return(1);
}



//************************************************************************/
//* Fehler Melde Funktion
//************************************************************************/
void vFehlerMeldeFunktion(char *pcMeldung)
{
  //***************************************************
  // Variablen
  //***************************************************
  FILE *fFehler_Datei;     //Datei mit Fehlermeldungen
  struct stat Datei_Eigenschaften;

  #define FEHLER_DATEI_PFAD "Config/Fehler.log"

  //***************************************************
  // Code
  //***************************************************
  fFehler_Datei = fopen(FEHLER_DATEI_PFAD, "a");
  stat(FEHLER_DATEI_PFAD,&Datei_Eigenschaften);
  printf("Datei Größe %d \n",Datei_Eigenschaften.st_size);

  //Schreibe nur wenn Datei kleiner als 60000 Byte ist.
  //Also ca. 60kb.

  if(Datei_Eigenschaften.st_size<60000)
  {
    fprintf(fFehler_Datei,pcMeldung);
    fprintf(fFehler_Datei,"<br> \n");
  }
  fclose(fFehler_Datei);

  return;
}
