//******************************************************************************
// EinzelWert.c
//******************************************************************************
//  Autor          Datum       Version       Änderung
//  boigk.net      12.02.2020   0.1          Start
//******************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>



#define ANZAHL_BYTES 518
#define DATEN_OFFSET 5


void vFehlerMeldeFunktion(char *pcMeldung);

//************************************************************************/
//* main Funktion
//************************************************************************/
int main(int iAnzahlParameter, char *argv[])
{
  //***************************************************
  // Variablen
  //***************************************************
  char Buffer[ANZAHL_BYTES];     //Puffer für Daten
  int i;                         //Zählvariable für Schleife
  FILE *fDaten_Datei;            //Datei Handle für DMX Werte
  int iKanalnummer;
  int iKanalwert;

  //***************************************************
  // Code
  //***************************************************
      //***************************************************
      // Parameter Überprüfen
      //***************************************************
      if(iAnzahlParameter != 3)
      {
         printf("Anzahl der Argumente nicht korrekt.\n");
         printf("Befehl: EinzelWert [Kanalnummer] [Kanalwert]\n");
         vFehlerMeldeFunktion("Inkorrekte werte für Kanalwertänderung");
      }
      else
      {
         iKanalnummer=atoi(argv[1]);
         iKanalwert=atoi(argv[2]);
         if(iKanalnummer >= 512)
         {
            printf("DMX Kanalnummer zu groß! Wert ist:%d\n",iKanalnummer);
            vFehlerMeldeFunktion("Kanalnummer größer als 512");
            return(0);
         }
         if(iKanalwert > 255)
         {
            printf("DMX Kanalwert zu groß! Wert ist:%d\n",iKanalwert);
            vFehlerMeldeFunktion("Kanalwert groeser 255");
            return(0);
         }


      }


      //***************************************************
      // Hole Daten vom Dateisystem
      //***************************************************
      fDaten_Datei = fopen("Config/SendeDaten.dmx","r");
      if(fDaten_Datei == 0)
      {
         vFehlerMeldeFunktion("Einzel Wert SendeDaten.dmx fehlt!");
      }
      else
      {
        fread(Buffer,ANZAHL_BYTES,1,fDaten_Datei);
        //***************************************************
        // Schließe Datei
        //***************************************************
        fclose(fDaten_Datei);
      }


      //***************************************************
      // Ändern eines einzelnen Wertes
      //***************************************************
      Buffer[DATEN_OFFSET + iKanalnummer]=iKanalwert;

      //***************************************************
      // Öffne Datei zum Schreiben
      // Und schreibe zeilenweise konvertierte Daten
      //***************************************************
      fDaten_Datei = fopen("Config/SendeDaten.dmx","w+");
      if(fDaten_Datei == 0)
      {
         vFehlerMeldeFunktion("Einzel Wert Schreiben. Kann SendeDaten.dmx nicht öffnen!");
      }
      else
      {
        fwrite(Buffer,ANZAHL_BYTES,1,fDaten_Datei);
        fclose(fDaten_Datei);
      }


  return(1);
}


//************************************************************************/
//* Fehler Melde Funktion
//************************************************************************/
void vFehlerMeldeFunktion(char *pcMeldung)
{
  //***************************************************
  // Variablen
  //***************************************************
  FILE *fFehler_Datei;     //Datei mit Fehlermeldungen
  struct stat Datei_Eigenschaften;

  #define FEHLER_DATEI_PFAD "Config/Fehler.log"

  //***************************************************
  // Code
  //***************************************************
  fFehler_Datei = fopen(FEHLER_DATEI_PFAD, "a");
  stat(FEHLER_DATEI_PFAD,&Datei_Eigenschaften);
  printf("Datei Größe %d \n",Datei_Eigenschaften.st_size);

  //Schreibe nur wenn Datei kleiner als 60000 Byte ist.
  //Also ca. 60kb.

  if(Datei_Eigenschaften.st_size<60000)
  {
    fprintf(fFehler_Datei,pcMeldung);
    fprintf(fFehler_Datei,"<br> \n");
  }
  fclose(fFehler_Datei);

  return;
}
